package com.artemis;

import com.artemis.utils.ImmutableBag;
import java.lang.String;

@SuppressWarnings("all") public final class E {
  protected static SuperMapper _processingMapper;

  protected SuperMapper mappers;

  protected int entityId;

  public E init(SuperMapper mappers, int entityId) {
    this.mappers = mappers;
    this.entityId = entityId;
    return this;
  }

  public static E E(int entityId) {
    if(_processingMapper==null) throw new RuntimeException("SuperMapper system must be registered before any systems using E().");;
    return _processingMapper.getE(entityId);
  }

  public static E E(Entity entity) {
    return E(entity.getId());
  }

  public static E E() {
    return E(_processingMapper.getWorld().create());
  }

  public int id() {
    return entityId;
  }

  public Entity entity() {
    return mappers.getWorld().getEntity(entityId);
  }

  public E tag(String tag) {
    mappers.getWorld().getSystem(com.artemis.managers.TagManager.class).register(tag, entityId);
    return this;
  }

  public String tag() {
    return mappers.getWorld().getSystem(com.artemis.managers.TagManager.class).getTag(entityId);
  }

  public E group(String group) {
    World w = mappers.getWorld();
    w.getSystem(com.artemis.managers.GroupManager.class).add(w.getEntity(entityId), group);
    return this;
  }

  public E groups(String... groups) {
    for (int i = 0; groups.length > i; i++) { group(groups[i]); };
    return this;
  }

  public E removeGroup(String group) {
    World w = mappers.getWorld();
    w.getSystem(com.artemis.managers.GroupManager.class).remove(w.getEntity(entityId), group);
    return this;
  }

  public E removeGroups(String... groups) {
    for (int i = 0; groups.length > i; i++) { removeGroup(groups[i]); };
    return this;
  }

  public E removeGroups() {
    World w = mappers.getWorld();
    w.getSystem(com.artemis.managers.GroupManager.class).removeFromAllGroups(w.getEntity(entityId));
    return this;
  }

  public ImmutableBag<String> groups() {
    World w = mappers.getWorld();
    return w.getSystem(com.artemis.managers.GroupManager.class).getGroups(w.getEntity(entityId));
  }

  public boolean isInGroup(String group) {
    World w = mappers.getWorld();
    return w.getSystem(com.artemis.managers.GroupManager.class).isInGroup(w.getEntity(entityId), group);
  }

  public void deleteFromWorld() {
    mappers.getWorld().delete(entityId);
  }
}
